#pragma once

#include <vector>
#include <string>

#include "CnvHankakuZenkaku.h"
#include "OnigRegex.h"

#include "ls11_mod.h"
#include "DotNetTestToMultiByte.h"


using namespace System;
using namespace System::Text;
using namespace System::Drawing;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;
using namespace System::Text::RegularExpressions;


char *szCastleTargetFileName = "sfile[1-5].dat"; // 

// 傤 vBufCastleDecodedData[0]=PԖڂ̕t@C̃f[^AvBufCastleDecodedData[1]=QԖڂ̕t@C̃f[^A݂Ȋ
vector<vector<byte>> vBufCastleDecodedData;


struct CastleType {
	char binAppearanceScenario[100]; // oViIoCi
	char szFullName[32];
	char szRubyYomi[32];
};
struct CastleTypeRetsuden {
	char szRetsuden[512];
};


vector<vector<CastleType>> vCastleInfoListData; // \̂ɂȂălXg
vector<vector<CastleTypeRetsuden>> vCastleRetsudenInfoListData; // \̂ɂȂălXg

ref class CastleData {
public:
	List<String^>^ lstStrFullName; // 
	List<String^>^ lstStrRubyYomi; // ݂
	List<String^>^ lstStrRetsuden; // `
	List<String^>^ lstStrBornEtc;  // `̌ɂ悭킩Ȃf[^

public:
	CastleData() {
		lstStrFullName = gcnew List<String^>();
		lstStrRubyYomi = gcnew List<String^>();
		lstStrBornEtc  = gcnew List<String^>();
		lstStrRetsuden = gcnew List<String^>();

		CastleData_Import();
	}

	//  u
	std::string StrReplace( std::string String1, std::string String2, std::string String3 )
	{
		std::string::size_type  Pos( String1.find( String2 ) );

		while( Pos != std::string::npos )
		{
			String1.replace( Pos, String2.length(), String3 );
			Pos = String1.find( String2, Pos + String3.length() );
		}

		return String1;
	}

	std::string HankakuKatakanaToZentakuKatakana(std::string szBufOriginal) {

		// ƃobt@ȂȂ̂ŁAȂ
		// HDp̃pb`
		return szBufOriginal;

		/*
		std::string szBufCurrent = szBufOriginal;

		Matches matches;

		// ̓ȋL͓VċLɂāApJ^JiSpJ^JiɂƂӖ
		for (int i=0; OnigMatch(szBufCurrent, "^(.*?)\x1b\x4b(.*?)\x1b\x48(.*?)$", &matches) && i<(int)szBufCurrent.size(); i++ ) { 
			// `vf𒊏oB
			if ( !matches[2].empty() ) {
				char szBufZenKatakana[256] = "";
				hankana2zenkana((unsigned char *)matches[2].c_str(), (unsigned char *)szBufZenKatakana);
				szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				szBufCurrent = matches[1] + szBufZenKatakana + matches[3];
			}
		}

		// Ō̕LȂ܂܍s}ꍇB
		if ( OnigMatch(szBufCurrent, "^(.*?)\x1b\x4b(.+)$", &matches) ) {

			// `vf𒊏oB
			if ( !matches[2].empty() ) {
				char szBufZenKatakana[256] = "";
				hankana2zenkana((unsigned char *)matches[2].c_str(), (unsigned char *)szBufZenKatakana);
				szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				szBufCurrent = matches[1] + szBufZenKatakana;
			}
		}

		return szBufCurrent;

		*/
	}


	// OnUnmanagedManagedւƒoB
	void NameAssignManagedData(char *pUnmanagedLine) {
		string nestline = string(pUnmanagedLine);

		// P̃Cɕ̏邪܂܂ĂꍇBőŃViIłU܂܂B
		Matches matches;

		vector<CastleType> nest;

		for ( int i=0; i<6; i++ ) {

			// ̏邪PɎ܂ĂꍇÂ悤Ȍ`B\x05Qȏ゠͂B
			if ( OnigMatch(nestline, "^(.+)\x05\x05\x05(.*?)\x05\x05\x05$", &matches ) ) {

				string prev = matches[1]; // OɂĂc̏
				string last = matches[2]; // ŌɂĂ()
				CastleType ct = {NULL};


				// O̊Ȃ́uoViIṽVOiŁA=\doViI̔ԍ
				if ( OnigMatch(last, "^(\x01.*=\x25\\d)?(.*?)\x20\x1b\x6b(.*?)$", &matches) ) {
					
					// ͕lXg̍Ō̂PiĈ́j݂͑AȊO͂ĂB
					// matches[1]==""ƂƂ́uĂ̗̂]̃ViIvł邱ƂӖB
					strcpy( ct.binAppearanceScenario, matches[1].c_str() );

					// 閼͐΂ɑ݂Ȃ΂ȂȂ
					// pJ^JiSpЂ炪Ȃ̗̂
					string strFullName = HankakuKatakanaToZentakuKatakana(matches[2].c_str());

					// 閼͐΂ɑ݂Ȃ΂ȂȂ
					strcpy( ct.szFullName, strFullName.c_str() );

					// 閼͐΂ɑ݂Ȃ΂ȂȂ
					strcpy( ct.szRubyYomi, matches[3].c_str() );

					nest.push_back(ct);

				}

				nestline = prev + "\x05\x05\x05"; // ԍŌ̂P
			}

			// ̏邪PɎ܂ĂꍇÂ悤Ȍ`B\x05Qȏ゠͂B
			// O̊Ȃ́uoViIṽVOiŁA=\doViI̔ԍ
			else if ( OnigMatch(nestline, "^(\x01.*=\x25\\d)?(.*?)\x20\x1b\x6b(.*?)\x05\x05\x05$", &matches) ) {
				CastleType ct = {NULL};

				// ͕lXg̍Ō̂PiĈ́j݂͑AȊO͂ĂB
				// matches[1]==""ƂƂ́uĂ̗̂]̃ViIvł邱ƂӖB
				strcpy( ct.binAppearanceScenario, matches[1].c_str() );

				// 閼͐΂ɑ݂Ȃ΂ȂȂ
				// pJ^JiSpЂ炪Ȃ̗̂
				string strFullName = HankakuKatakanaToZentakuKatakana(matches[2].c_str());

				strcpy( ct.szFullName, strFullName.c_str() );

				// 閼͐΂ɑ݂Ȃ΂ȂȂ
				strcpy( ct.szRubyYomi, matches[3].c_str() );

				nest.push_back(ct);

				nestline = "";
			}
		}


		// st܂߁A͍킹̂o
		lstStrFullName->Add( gcnew String(nest[0].szFullName) );

		// _~[BƃR|[lg̐킹邽߂̂
		lstStrRubyYomi->Add( gcnew String(nest[0].szRubyYomi) );

		// _~[BƃR|[lg̐킹邽߂̂
		lstStrBornEtc->Add( gcnew String("") );

		// 邪PɃpbNꂽ̂(PȂ)AS̃XgւƒǉB
		vCastleInfoListData.push_back(nest);

	}


	String^ RetsudenAssignManagedData(char *pUnmanagedLine, int ix) {

		string nestline = string(pUnmanagedLine);

		// P̃Cɕ̏邪܂܂ĂꍇBőŃViIłU܂܂B
		Matches matches;

		vector<CastleTypeRetsuden> nest;

		for ( int i=0; i<6; i++ ) {

			// ̏邪PɎ܂ĂꍇÂ悤Ȍ`B\x05Qȏ゠͂B
			if ( OnigMatch(nestline, "^(.+)\x05\x05\x05(.*?)\x05\x05\x05$", &matches ) ) {

				string prev = matches[1]; // OɂĂc̏
				string last = matches[2]; // ŌɂĂ()
				CastleTypeRetsuden ctr = {NULL};


				// O̊Ȃ́uoViIṽVOiŁA=\doViI̔ԍ
				if ( OnigMatch(last, "^(\x01.*=\x25\\d)?(.*?)$", &matches) ) {

					string szBufCurrent = HankakuKatakanaToZentakuKatakana(matches[2].c_str());

					// ćApJ^JiSpЂ炪Ȃ
					char szBufZenHiragana[256] = "";
					hankana2zenhira((unsigned char *)szBufCurrent.c_str(), (unsigned char *)szBufZenHiragana);
					szBufZenHiragana[255] = NULL; // ȏCĂ\Ȃ悤Ô

					string strZenHiragana = string(szBufZenHiragana);

					// sIӖ̂̂ȋLɒuB̂߁B
					for (int i=0; OnigMatch(strZenHiragana, "^(.*?)\x0A(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
						// `vf𒊏oB
						if ( !matches[1].empty() ) {
							strZenHiragana = matches[1] + "<r><n>" + matches[2];
						}
					}

					// ȋLA`GfB^ł̌ڂ̉sւƕϊB
					for (int i=0; OnigMatch(strZenHiragana, "^(.*?)<r><n>(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
						// `vf𒊏oB
						if ( !matches[1].empty() ) {
							strZenHiragana = matches[1] + "\r\n" + matches[2];
						}
					}

					strcpy(ctr.szRetsuden, strZenHiragana.c_str());
					nest.push_back(ctr);
				}

				nestline = prev + "\x05\x05\x05"; // ԍŌ̂P
			}
			// ̏邪PɎ܂ĂꍇÂ悤Ȍ`B\x05Qȏ゠͂B
			// O̊Ȃ́uoViIṽVOiŁA=\doViI̔ԍ
			else if ( OnigMatch(nestline, "^(\x01.*=\x25\\d)?(.*?)\x05\x05\x05$", &matches) ) {

				CastleTypeRetsuden ctr = {NULL};
				string szBufCurrent = HankakuKatakanaToZentakuKatakana(matches[2].c_str());

				// ćApJ^JiSpЂ炪Ȃ
				char szBufZenHiragana[256] = "";
				hankana2zenhira((unsigned char *)szBufCurrent.c_str(), (unsigned char *)szBufZenHiragana);
				szBufZenHiragana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				string strZenHiragana = string(szBufZenHiragana);

				// sIӖ̂̂ȋLɒuB̂߁B
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)\x0A(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "<r><n>" + matches[2];
					}
				}

				// ȋLA`GfB^ł̌ڂ̉sւƕϊB
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)<r><n>(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "\r\n" + matches[2];
					}
				}

				strcpy(ctr.szRetsuden, strZenHiragana.c_str());
				nest.push_back(ctr);

				nestline = "";

			}
		}

		// 邪PɃpbNꂽ̂(PȂ)AS̃XgւƒǉB
		vCastleRetsudenInfoListData.push_back(nest);

		return gcnew String(nest[0].szRetsuden);
	}


	// `nUnmanagedManagedւƒoB
	String^ RetsudenAssignManagedDataSub(char *pUnmanagedLine) {

		string szBufCurrent = string(pUnmanagedLine);

		szBufCurrent = HankakuKatakanaToZentakuKatakana(szBufCurrent);

		Matches matches;
		// Ō̏ILȍ~͏B
		if ( OnigMatch(szBufCurrent, "^(.*?)\x05\x05\x05$", &matches) ) {

			if ( !matches[1].empty() ) {
				// ćApJ^JiSpЂ炪Ȃ
				char szBufZenHiragana[256] = "";
				hankana2zenhira((unsigned char *)matches[1].c_str(), (unsigned char *)szBufZenHiragana);
				szBufZenHiragana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				string strZenHiragana = string(szBufZenHiragana);

				// sIӖ̂̂ȋLɒuB̂߁B
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)\n(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "<r><n>" + matches[2];
					}
				}

				// ȋLA`GfB^ł̌ڂ̉sւƕϊB
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)<r><n>(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "\r\n" + matches[2];
					}
				}
				return gcnew String(strZenHiragana.c_str());
			}
		}

		return gcnew String("");
	}



	// sfile*.datzւƊi[B
	int CastleData_Import() {
		if (!System::IO::File::Exists(gcnew String("sfile1.dat"))) {
			System::Windows::Forms::MessageBox::Show("sfile*.datǂݍ߂܂", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
		}

		int iRetsudenNo = -1;

		vBufCastleDecodedData.resize(5);

		for (int ifile = 0; ifile < (int)vBufCastleDecodedData.size(); ifile++) {
			char szFileName[MAX_PATH] = "";
			sprintf(szFileName, "sfile%d.dat", ifile + 1);
			FILE *fp = fopen(szFileName, "rb");

			// t@CTCY
			fpos_t fsize = 0;
			fpos_t fsizeb = fseek(fp, 0, SEEK_END);
			fgetpos(fp, &fsize);

			// ւƖ߂
			rewind(fp);

			byte buf[20000]; // ̂߁AnewȂB

							 // Rs[
			fread(buf, (size_t)fsize, 1, fp);

			// 95łƈāA擪Ɂu64 00vƂ悤ɑS100f[^Ƃ񂪕tĂB
			WORD *pDataAddress = (WORD *)buf;
			WORD iDataCount = pDataAddress[0]; // 擪̓f[^̌
			for (int i = 1; i <= iDataCount; i++) {
				pDataAddress[i] = pDataAddress[i] - 2; // SAhXQ
			}

			vector<byte> vdata(&buf[2], &buf[fsize]); // ŏWORDP95łɂ͖JEgȂ̂ŃRs[ȂB
			vBufCastleDecodedData[ifile] = vdata;
		}

		// fR[hf[^(I)t@Cł܂킵ĂB0Ԃ͑Ώۂł͂ȂBf[^1ԂB
		int ivBufDecodedDataSize = vBufCastleDecodedData.size();

		// 18ԖڂX^[gĂ!! !!
		for (int ifile = 0; ifile < (int)vBufCastleDecodedData.size(); ifile++) {

			// 傤 vSplittedData[0]=PԖڂ̗vf̃f[^AvSplittedData[1]=QԖڂ̗vf̃f[^A݂Ȋ
			vector<vector<byte>> vSplittedData;

			ls11_SplitData( vBufCastleDecodedData[ifile], &vSplittedData );

			int ivSplittedDataSize = vSplittedData.size();

			// evfƂɥ 
			for ( int ielem=0; ielem < (int)ivSplittedDataSize; ielem++ ) {
				if ( ielem%2==0 ) { iRetsudenNo++; }

				if ( iRetsudenNo < 0 ) { iRetsudenNo = 0; }; // ň̂߂̔ԕ

				// ǂ݉Ƃ
				if ( ielem%2==0 ) {

					int datasize = vSplittedData[ielem].size();
					if ( datasize > 0 ) {

						char *bytedata = new char[datasize+1];
						memcpy( bytedata, &vSplittedData[ielem][0], datasize );
						bytedata[datasize] = NULL; // ԕ

						NameAssignManagedData( bytedata ); // }l[Whf[^ւƑ

						delete bytedata;
					}


				// ͗`B
				} else { 

					string szBufCurrent;

					int datasize = vSplittedData[ielem].size();
					if ( datasize > 0 ) {

						char *bytedata = new char[datasize+1];
						memcpy( bytedata, &vSplittedData[ielem][0], datasize );
						bytedata[datasize] = NULL; // ԕ
						szBufCurrent = string(bytedata); 

						String^ strRetsuden = RetsudenAssignManagedData( bytedata, ielem/2 ); // }l[Whf[^ւƑ
						lstStrRetsuden->Add( strRetsuden );

						delete bytedata;
					}

				}
			}
		}

		// v`ԂB
		return iRetsudenNo+1;
	}

	std::string GetOutputFormatNormalizeData(std::string unmanagedData) {

		Matches matches;
		// ȋLA`GfB^ł̌ڂ̉sւƕϊB
		for (int i=0; OnigMatch(unmanagedData, "^(.*?)\r\n(.+)", &matches) && i<(int)unmanagedData.size(); i++ ) { 
			// `vf𒊏oB
			if ( !matches[1].empty() ) {
				unmanagedData = matches[1] + "\x0A" + matches[2];
			}
		}

		return unmanagedData;
	}

	// ƂPl̏f[^t@C
	BOOL GetOneCastleImportData(String^ managedFilePath, int iSelectedIndex) {
		return FALSE;
	}

	BOOL AllSaveToMessageN6P() {
		vBufCastleDecodedData.clear(); // [S
									  // ƕ`SĂɂĥ
		int iFileCnt = (int)ceil((double)lstStrFullName->Count / 50.0); // zt@C()JEgBP50Ȃ̂ŁB

																   // ꂼ̉ƕԍ̊Jnԍ𑗂ȂAzt@Ct@CJԂBvBufKahouDecodedData ɕtĂ䂭B
		for (int f = 0; f<iFileCnt; f++) {
			MakeSplittedDataToJoindData(f * 50);
		}

		int result = 0;
		for (int ifile = 0; ifile < (int)vBufCastleDecodedData.size(); ifile++) {
			char szFileName[MAX_PATH] = "";
			sprintf(szFileName, "ifile%d.dat", ifile + 1);
			FILE *fp = fopen(szFileName, "wb");
			if (!fp) {
				result = -1;
			}
			byte tmpBuf[20000];
			int iDataSize = vBufCastleDecodedData[ifile].size();
			memcpy(tmpBuf, vBufCastleDecodedData[ifile].data(), iDataSize);
			fwrite(tmpBuf, iDataSize, 1, fp);
			fclose(fp);
		}

		if (result == 0) {
			System::Windows::Forms::MessageBox::Show(gcnew String(szCastleTargetFileName) + "ւƏo͂܂B", "", MessageBoxButtons::OK, ::MessageBoxIcon::Information);
			return TRUE;
		}
		else {
			System::Windows::Forms::MessageBox::Show("\ʃG[܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return FALSE;
		}
	}

	// P̉zt@C(ꂽ̑)ɍoB
	void MakeSplittedDataToJoindData(int iStartIndex ) {
		vector<vector<byte>> vSplittedData; // 50 lł䂭f[^
		vector<byte> vDstJoinedData; // 50 lł䂭f[^

									 // 50l
		for (int i = iStartIndex; (i < iStartIndex + 50) && (i < lstStrFullName->Count); i++) {
			vSplittedData.push_back(GetNameLineData(i));
			vSplittedData.push_back(GetRetsudenLineData(i));
		}

		// ̂ւƖ߂BPt@C
		ls11_JoinData(vSplittedData, &vDstJoinedData);

		// 擪Ƀf[^Ŝ̃AhX𑀍삷B
		int iDataByteSize = vDstJoinedData.size();
		int iAllDataByteSize = iDataByteSize + 2;
		byte tmpBuf[20000] = { 0 };
		memcpy(tmpBuf + 2, vDstJoinedData.data(), iDataByteSize);
		int iAddress = (int)tmpBuf + 2;
		WORD *wAddress = (WORD *)iAddress;

		int iDataSplittedCount = vSplittedData.size(); // Ăf[^
		for (int i = 0; i < iDataSplittedCount; i++) {
			wAddress[i] = wAddress[i] + 2; // Q{ƕA擪Ƀ^X\Ȃ̂ŁAAhX炵Ă
		}
		tmpBuf[0] = (byte)iDataSplittedCount; // 擪Ƀf[^̌ݒ
		vDstJoinedData.clear();

		vector<byte> vNewJoindData(&tmpBuf[0], &tmpBuf[iAllDataByteSize]);
		// S̃f[^ɉB
		vBufCastleDecodedData.push_back(vNewJoindData);
	}

	// ƂPl̖̏ONñf[^
	vector<byte> GetNameLineData(int iTargetIndex) {

		std::string unmanagedData = "";
		int packcnt = vCastleInfoListData[iTargetIndex].size();

		// pbNĂ镪AS
		for ( int j=0; j <packcnt; j++ ) {
			unmanagedData = 
				string("") + vCastleInfoListData[iTargetIndex][j].binAppearanceScenario +
				vCastleInfoListData[iTargetIndex][j].szFullName + "\x20\x1b\x6b" +
				vCastleInfoListData[iTargetIndex][j].szRubyYomi + "\x05\x05\x05" +
				unmanagedData;
		}

		char *psz = (char *)unmanagedData.c_str();

		// Cchar[]vector<byte>ւƃRs[
		vector<byte> line( &psz[0], &psz[strlen(psz)] );

		return line;
	}

	// Ƃ1l̗̏`f[^
	vector<byte> GetRetsudenLineData(int iTargetIndex) {
		std::string unmanagedData = "";
		int packcnt = vCastleRetsudenInfoListData[iTargetIndex].size();

		// pbNĂ镪AS
		for ( int j=0; j <packcnt; j++ ) {
			unmanagedData = 
				string("") + vCastleInfoListData[iTargetIndex][j].binAppearanceScenario +
				GetOutputFormatNormalizeData( vCastleRetsudenInfoListData[iTargetIndex][j].szRetsuden ) + "\x05\x05\x05" +
				unmanagedData;
		}

		char *psz = (char *)unmanagedData.c_str();

		// Cchar[]vector<byte>ւƃRs[
		vector<byte> line( &psz[0], &psz[strlen(psz)] );

		return line;

	}

};