#pragma once

#include <vector>
#include <string>
#include <fstream>

#include "CnvHankakuZenkaku.h"
#include "OnigRegex.h"

#include "ls11_mod.h"
#include "DotNetTestToMultiByte.h"


using namespace System;
using namespace System::Text;
using namespace System::Drawing;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;
using namespace System::Text::RegularExpressions;


char *szKahouTargetFileName = "ifile[1-3].dat"; // 

// 傤 vBufKahouDecodedData[0]=PԖڂ̕t@C̃f[^AvBufKahouDecodedData[1]=QԖڂ̕t@C̃f[^A݂Ȋ
vector<vector<byte>> vBufKahouDecodedData;


ref class KahouData {
public:
	List<String^>^ lstStrFullName; // 
	List<String^>^ lstStrRubyYomi; // ݂
	List<String^>^ lstStrRetsuden; // `
	List<String^>^ lstStrBornEtc;  // `̌ɂ悭킩Ȃf[^

public:
	KahouData() {
		lstStrFullName = gcnew List<String^>();
		lstStrRubyYomi = gcnew List<String^>();
		lstStrBornEtc  = gcnew List<String^>();
		lstStrRetsuden = gcnew List<String^>();

		KahouData_Import();
	}

	//  u
	std::string StrReplace( std::string String1, std::string String2, std::string String3 )
	{
		std::string::size_type  Pos( String1.find( String2 ) );

		while( Pos != std::string::npos )
		{
			String1.replace( Pos, String2.length(), String3 );
			Pos = String1.find( String2, Pos + String3.length() );
		}

		return String1;
	}

	std::string HankakuKatakanaToZentakuKatakana(std::string szBufOriginal) {
		// ƃobt@ȂȂ̂ŁAȂ
		// HDp̃pb`
		return szBufOriginal;

		/*

		std::string szBufCurrent = szBufOriginal;

		Matches matches;

		// ̓ȋL͓VċLɂāApJ^JiSpJ^JiɂƂӖ
		for (int i=0; OnigMatch(szBufCurrent, "^(.*?)\x1b\x4b(.*?)\x1b\x48(.*?)$", &matches) && i<(int)szBufCurrent.size(); i++ ) { 
			// `vf𒊏oB
			if ( !matches[2].empty() ) {
				char szBufZenKatakana[256] = "";
				hankana2zenkana((unsigned char *)matches[2].c_str(), (unsigned char *)szBufZenKatakana);
				szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				szBufCurrent = matches[1] + szBufZenKatakana + matches[3];
			}
		}

		// Ō̕LȂ܂܍s}ꍇB
		if ( OnigMatch(szBufCurrent, "^(.*?)\x1b\x4b(.+)$", &matches) ) {

			// `vf𒊏oB
			if ( !matches[2].empty() ) {
				char szBufZenKatakana[256] = "";
				hankana2zenkana((unsigned char *)matches[2].c_str(), (unsigned char *)szBufZenKatakana);
				szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				szBufCurrent = matches[1] + szBufZenKatakana;
			}
		}

		return szBufCurrent;

		*/

	}

	int replace_string(char* src, const char* before, const char* after) {
		char* find_pos;
		if (NULL == src || NULL == before || NULL == after) {
			return 0;
		}
		find_pos = strstr(src, before);
		if (NULL == find_pos) {
			return 0;
		}
		if (strlen(before) < strlen(after)) {
			src = (char *)realloc(src, strlen(src) + strlen(after) + 1 - strlen(before));
			memmove(find_pos + strlen(after), find_pos + strlen(before),
				strlen(src) - strlen(before) - (find_pos - src) + 1);
			memcpy(find_pos, after, strlen(after));
		}
		else {
			memcpy(find_pos, after, strlen(after));
			if (strlen(before) > strlen(after)) {
				memmove(find_pos + strlen(after), find_pos + strlen(before),
					strlen(src) - strlen(before) - (find_pos - src) + 1);
			}
		}
		return 1;
	}

	// OnUnmanagedManagedւƒoB
	void NameAssignManagedData(char *pUnmanagedLine) {
		string line = string(pUnmanagedLine);
		Matches matches;
		if ( OnigMatch(line, "^\x1b\x6b(.*?)\x1b\x48\n(.*?)\x05\x05\x05$", &matches) ) {

			matches[2] = HankakuKatakanaToZentakuKatakana(matches[2]);

			String^ strFullName = gcnew String(matches[2].c_str());
			lstStrFullName->Add( strFullName );

			String^ strRubyYomi = gcnew String(matches[1].c_str());
			lstStrRubyYomi->Add(strRubyYomi);

			// _~[BƃR|[lg̐킹邽߂̂
			lstStrBornEtc->Add( gcnew String("") );
		}
	}

	// Addłł͂ȂāA㏑š Ђǂ\[XɂȂĂorz
	BOOL NameOverrideManagedData(char *pUnmanagedLine, int iSelectedIndex) {
		string line = string(pUnmanagedLine);
		Matches matches;
		if ( OnigMatch(line, "^\x1b\x6b(.*?)\x1b\x48(.*?)\x05\x05\x05$", &matches) ) {

			matches[2] = HankakuKatakanaToZentakuKatakana(matches[2]);

			// IĂƂɏ㏑
			String^ strFullName = gcnew String(matches[2].c_str());
			lstStrFullName[iSelectedIndex] = strFullName;

			String^ strRubyYomi = gcnew String(matches[1].c_str());
			lstStrRubyYomi[iSelectedIndex] = strRubyYomi;

			lstStrBornEtc->Add( gcnew String("") );

			return TRUE;
		}
		return FALSE;
	}

	// `nUnmanagedManagedւƒoB
	String^ RetsudenAssignManagedData(char *pUnmanagedLine) {

		string szBufCurrent = string(pUnmanagedLine);

		szBufCurrent = HankakuKatakanaToZentakuKatakana(szBufCurrent);

		Matches matches;
		// Ō̏ILȍ~͏B
		if ( OnigMatch(szBufCurrent, "^(.*?)\x05\x05\x05$", &matches) ) {

			if ( !matches[1].empty() ) {
				// ćApJ^JiSpЂ炪Ȃ
				char szBufZenHiragana[256] = "";
				hankana2zenhira((unsigned char *)matches[1].c_str(), (unsigned char *)szBufZenHiragana);
				szBufZenHiragana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				string strZenHiragana = string(szBufZenHiragana);

				// sIӖ̂̂ȋLɒuB̂߁B
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)\n(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "<r><n>" + matches[2];
					}
				}

				// ȋLA`GfB^ł̌ڂ̉sւƕϊB
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)<r><n>(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "\r\n" + matches[2];
					}
				}
				return gcnew String(strZenHiragana.c_str());
			}
		}

		return gcnew String("");
	}



	// ifile*.datzւƊi[B
	int KahouData_Import() {
		if (! System::IO::File::Exists( gcnew String("ifile1.dat") ) ) {
			System::Windows::Forms::MessageBox::Show("ifile*.datǂݍ߂܂", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
		}

		int iRetsudenNo = -1;

		vBufKahouDecodedData.resize(3);

		for (int ifile = 0; ifile <= 2; ifile++) {
			char szFileName[MAX_PATH] = "";
			sprintf(szFileName, "ifile%d.dat", ifile+1);
			FILE *fp = fopen(szFileName, "rb");

			// t@CTCY
			fpos_t fsize = 0;
			fpos_t fsizeb = fseek(fp, 0, SEEK_END);
			fgetpos(fp, &fsize);

			// ւƖ߂
			rewind(fp);

			byte buf[20000]; // ̂߁AnewȂB

			// Rs[
			fread(buf, (size_t)fsize, 1, fp);

			// 95łƈāA擪Ɂu64 00vƂ悤ɑS100f[^Ƃ񂪕tĂB
			WORD *pDataAddress = (WORD *)buf;
			WORD iDataCount = pDataAddress[0]; // 擪̓f[^̌
			for (int i = 1; i <= iDataCount; i++) {
				pDataAddress[i] = pDataAddress[i] - 2; // SAhXQ
			}

			vector<byte> vdata(&buf[2], &buf[fsize]); // ŏWORDP95łɂ͖JEgȂ̂ŃRs[ȂB
			vBufKahouDecodedData[ifile] = vdata;
		}

		// 1ԖڂX^[gĂ!! !!
		for ( int ifile = 0; ifile <= 2; ifile++ ) {

			// 傤 vSplittedData[0]=PԖڂ̗vf̃f[^AvSplittedData[1]=QԖڂ̗vf̃f[^A݂Ȋ
			vector<vector<byte>> vSplittedData;

			ls11_SplitData( vBufKahouDecodedData[ifile], &vSplittedData );

			int ivSplittedDataSize = vSplittedData.size();

			// evfƂɥ ܂OAǂ݉ vN̗
			for ( int ielem=0; ielem < (int)ivSplittedDataSize; ielem++ ) {
				if ( ielem%2==0 ) { iRetsudenNo++; }

				if ( iRetsudenNo < 0 ) { iRetsudenNo = 0; }; // ň̂߂̔ԕ

				// ǂ݉Ƃ
				if ( ielem%2==0 ) {

					int datasize = vSplittedData[ielem].size();
					if ( datasize > 0 ) {

						char *bytedata = new char[datasize+1];
						memcpy( bytedata, &vSplittedData[ielem][0], datasize );
						bytedata[datasize] = NULL; // ԕ

						NameAssignManagedData( bytedata ); // }l[Whf[^ւƑ

						delete bytedata;
					}


				// ͗`B
				} else { 

					string szBufCurrent;

					int datasize = vSplittedData[ielem].size();
					if ( datasize > 0 ) {

						char *bytedata = new char[datasize+1];
						memcpy( bytedata, &vSplittedData[ielem][0], datasize );
						bytedata[datasize] = NULL; // ԕ
						szBufCurrent = string(bytedata); 

						String^ strRetsuden = RetsudenAssignManagedData( bytedata ); // }l[Whf[^ւƑ
						lstStrRetsuden->Add( strRetsuden );

						delete bytedata;
					}

				}
			}
		}

		// v`ԂB
		return iRetsudenNo+1;
	}

	// ƂPl̉ƕf[^̏o͗poCif[^𓾂
	std::string GetOneKahouExportData(int iSelectedIndex) {
		String^ managedData = String::Format("\x1b\x6b{0}\x1b\x48\x0A{1}\x05\x05\x05{2}", lstStrRubyYomi[iSelectedIndex], lstStrFullName[iSelectedIndex], lstStrRetsuden[iSelectedIndex] );

		return GetOutputFormatNormalizeData(managedData);

	}

	std::string GetOutputFormatNormalizeData(String^ managedData) {
		// .NET^CvString^  }`oCgC++^std::string
		std::string unmanagedData = DotNetStringToMultiByte(managedData);

		Matches matches;
		// ȋLA`GfB^ł̌ڂ̉sւƕϊB
		for (int i=0; OnigMatch(unmanagedData, "^(.*?)\r\n(.+)", &matches) && i<(int)unmanagedData.size(); i++ ) { 
			// `vf𒊏oB
			if ( !matches[1].empty() ) {
				unmanagedData = matches[1] + "\x0A" + matches[2];
			}
		}

		return unmanagedData;
	}

	// ƂPl̉ƕf[^t@C
	BOOL GetOneKahouImportData(String^ managedFilePath, int iSelectedIndex) {
		std::string unmanagedFilePath = DotNetStringToMultiByte(managedFilePath);

		FILE *fp = fopen( unmanagedFilePath.c_str(), "rb");
		if ( fp ) {
			char pUnmanagedLine[512] = "";
			fread( pUnmanagedLine, sizeof(pUnmanagedLine)-1, 1, fp); // Cɓǂݍ
			fclose(fp);


			string line = string(pUnmanagedLine);
			Matches matches;
			if ( OnigMatch(line, "^\x1b\x6b(.*?)\x1b\x48(.*?\x05\x05\x05$)", &matches) ) {

				BOOL ret1 = NameOverrideManagedData(pUnmanagedLine, iSelectedIndex);

				if (!ret1) {
					System::Windows::Forms::MessageBox::Show("f[^̎捞Ɏs܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
					return FALSE;
				}

				// `n
				String^ strRetsuden = RetsudenAssignManagedData((char *)matches[3].c_str());

				lstStrRetsuden[iSelectedIndex] = strRetsuden;

				System::Windows::Forms::MessageBox::Show("f[^荞݂܂BB", "", MessageBoxButtons::OK, ::MessageBoxIcon::Information);
				return TRUE;
			}

		} else {
			System::Windows::Forms::MessageBox::Show("t@C̃I[vɎs܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return FALSE;
		}

		return FALSE;
	}

	BOOL AllSaveToMessageN6P() {
		vBufKahouDecodedData.clear(); // [S
									   // ƕ`SĂɂĥ
		int iFileCnt = (int)ceil((double)lstStrFullName->Count / 50.0); // zt@C()JEgBP50Ȃ̂ŁB

												   // ꂼ̉ƕԍ̊Jnԍ𑗂ȂAzt@Ct@CJԂBvBufKahouDecodedData ɕtĂ䂭B
		for (int f = 0; f<iFileCnt; f++) {
			MakeSplittedDataToJoindData(f * 50);
		}

		int result = 0;
		for (int ifile = 0; ifile < (int)vBufKahouDecodedData.size(); ifile++) {
			char szFileName[MAX_PATH] = "";
			sprintf(szFileName, "ifile%d.dat", ifile + 1);
			FILE *fp = fopen(szFileName, "wb");
			if (!fp) {
				result = -1;
			}
			byte tmpBuf[20000];
			int iDataSize = vBufKahouDecodedData[ifile].size();
			memcpy(tmpBuf, vBufKahouDecodedData[ifile].data(), iDataSize);
			fwrite(tmpBuf, iDataSize, 1, fp);
			fclose(fp);
		}

		if (result == 0) {
			System::Windows::Forms::MessageBox::Show(gcnew String(szKahouTargetFileName) + "ւƏo͂܂B", "", MessageBoxButtons::OK, ::MessageBoxIcon::Information);
			return TRUE;
		}
		else {
			System::Windows::Forms::MessageBox::Show("\ʃG[܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return FALSE;
		}
	}

	// P̉zt@C(ꂽ̑)ɍoB
	void MakeSplittedDataToJoindData(int iStartIndex) {
		vector<vector<byte>> vSplittedData; // 50 lł䂭f[^
		vector<byte> vDstJoinedData; // 50 lł䂭f[^

									 // 50l
		for (int i = iStartIndex; (i < iStartIndex + 50) && (i < lstStrFullName->Count); i++) {
			vSplittedData.push_back(GetNameLineData(i));
			vSplittedData.push_back(GetRetsudenLineData(i));
		}

		// ̂ւƖ߂BPt@C
		ls11_JoinData(vSplittedData, &vDstJoinedData);

		// 擪Ƀf[^Ŝ̃AhX𑀍삷B
		int iDataByteSize = vDstJoinedData.size();
		int iAllDataByteSize = iDataByteSize + 2;
		byte tmpBuf[20000] = { 0 };
		memcpy(tmpBuf + 2, vDstJoinedData.data(), iDataByteSize);
		int iAddress = (int)tmpBuf + 2;
		WORD *wAddress = (WORD *)iAddress;

		int iDataSplittedCount = vSplittedData.size(); // Ăf[^
		for (int i = 0; i < iDataSplittedCount; i++) {
			wAddress[i] = wAddress[i] + 2; // Q{ƕA擪Ƀ^X\Ȃ̂ŁAAhX炵Ă
		}
		tmpBuf[0] = (byte)iDataSplittedCount; // 擪Ƀf[^̌ݒ
		vDstJoinedData.clear();

		vector<byte> vNewJoindData(&tmpBuf[0], &tmpBuf[iAllDataByteSize]);
		// S̃f[^ɉB
		vBufKahouDecodedData.push_back(vNewJoindData);
	}

	// ƂPl̉ƕ̖ONñf[^
	vector<byte> GetNameLineData(int iTargetIndex) {

		String^ format = String::Format("\x1b\x6b{0}\x1b\x48\x0A{1}\x05\x05\x05", lstStrRubyYomi[iTargetIndex], lstStrFullName[iTargetIndex]);

		std::string unmanagedData = GetOutputFormatNormalizeData(format);

		char *psz = (char *)unmanagedData.c_str();

		// Cchar[]vector<byte>ւƃRs[
		vector<byte> line( &psz[0], &psz[strlen(psz)] );

		return line;
	}

	// Ƃ1l̉ƕ̗`f[^
	vector<byte> GetRetsudenLineData(int iTargetIndex) {
		String^ format = String::Format("{0}\x05\x05\x05", lstStrRetsuden[iTargetIndex]);

		std::string unmanagedData = GetOutputFormatNormalizeData(format);

		char *psz = (char *)unmanagedData.c_str();

		// Cchar[]vector<byte>ւƃRs[
		vector<byte> line( &psz[0], &psz[strlen(psz)] );

		return line;

	}

};